//bity od i do i+j-1
template<class T>
inline int Bit(T v,int i)
{
	return (v>>i)&1;
}

template<class T>
void XChangeRadixSort_rek(T *A,int l,int r,int pos)
{
	if (pos<0) return;
	if (r<=l) return;

	int i=l,j=r;
	
	while (i<j)
	{
		while (i<j && Bit(A[i],pos)==0) i++;
		while (i<j && Bit(A[j],pos)==1) j--;
		T tmp=A[i]; A[i]=A[j]; A[j]=tmp;
	}
	if (Bit(A[j],pos)==0) j++;
	XChangeRadixSort_rek(A,l,j-1,pos-1);
	XChangeRadixSort_rek(A,j,r,pos-1);
}

template<class T>
void XChangeRadixSort(T *A,int n)
{
	XChangeRadixSort_rek(A,0,n-1,sizeof(T)*8-1);
}
