template<class T>
void Merge(T *A1,T *A2,T *A3,int n1,int n2)
{
	int i1=0,i2=0,i=0;
	while (i1<n1 && i2<n2) A3[i++]=A1[i1]<A2[i2]? A1[i1++]:A2[i2++];
	while (i1<n1) A3[i++]=A1[i1++];
	while (i2<n2) A3[i++]=A2[i2++];
	
	memcpy(A1,A3,sizeof(T)*(n1+n2));
}

template<class T>
void MergeSort_rek(T *A,T *APom,int l,int r)
{
	if (r<=l) return;
	int p=(l+r)/2;
	MergeSort_rek(A,APom,l,p);
	MergeSort_rek(A,APom,p+1,r);
	Merge(A+l,A+p+1,APom,p-l+1,r-p);
}

template<class T>
void MergeSort(T *A,int n)
{
	T *pom=new T[n];
	MergeSort_rek(A,pom,0,n-1);
	delete []pom;
}
