#include <algorithm>
#include "insert_sort.h"

template<class T>
int Partition(T *A,int l,int r)
{
	int piv=l;
	T v=A[piv];
	l++;
	while (l<r)
	{
		if (A[l]<=v) l++;
		else
		{
			swap(A[l],A[r]);
			r--;
		}
	}
	if (A[l]==v) return l;
	else
	if (A[l]<v) {swap(A[piv],A[l]); return l;}
	else
	//A{l]>v
	{swap(A[piv],A[l-1]); return l-1;}
}

template<class T>
void qsort_rek(T *A,int l,int r)
{
	int p=Partition(A,l,r);
	if (l<p-1) qsort_rek(A,l,p-1);
	if (r>p+1) qsort_rek(A,p+1,r);
}

template<class T>
void qsort_rek0(T *A,int l,int r)
{
	while (l<r)
	{
		int p=Partition(A,l,r);
		if (p-1-l<r-p+1) 
		{
			qsort_rek0(A,l,p-1);
			l=p+1;
		}
		else
		{
			qsort_rek0(A,p+1,r);
			r=p-1;
		}
	}
}

template<class T>
void qsort_rek_inssort(T *A,int l,int r)
{
	if (r-l<20) InsertionSort_lr(A,l,r);
	else
	{
		int p=Partition(A,l,r);
		if (l<p-1) qsort_rek_inssort(A,l,p-1);
		if (r>p+1) qsort_rek_inssort(A,p+1,r);
	}
}

template<class T>
void QSort(T *A,int n,int no=0)
{
	switch(no)
	{
		case 0:qsort_rek(A,0,n-1); break;
		case 1:qsort_rek0(A,0,n-1); break;
		case 2:qsort_rek_inssort(A,0,n-1); break;
	}
}
