#include <windows.h>

static double _t1,_t2;

double inline GetTime()
{
 long long f,t;
 QueryPerformanceFrequency((PLARGE_INTEGER)&f);
 QueryPerformanceCounter((PLARGE_INTEGER)&t);
 return (double)t/(double)f;
}

#define start _t1=GetTime()
#define stop(txt) _t2=GetTime(); cout << txt << _t2-_t1 << endl

template<class T>
void check(T A[],int n)
{
	int ok=1;
	for (int i=1; i<n; i++) ok&=A[i]>=A[i-1];
	cout << (ok? "Ok":"Error!") << endl << endl;
}
